# Anbox Cloud - Anbox Stream Agent

Anbox Cloud offers a software stack that runs Android applications in any cloud enabling high-performance
streaming of graphics to desktop and mobile client devices.

At its heart, it uses lightweight container technology instead of full virtual machines to achieve higher
density and better performance per host while ensuring security and isolation of each container. Depending
on the target platform, payload, and desired application performance (e.g. frame rate), more than
100 containers can be run on a single machine.

For containerization of Android, Anbox Cloud uses the well established and secure container hypervisor
LXD. LXD is secure by design, scales to a large number of containers and provides advanced resource
management for hosted containers.

Also have a look at the official Anbox Cloud website for more information.

> NOTE: Anbox Cloud is a paid offering. You will need a Ubuntu Advantage subscription for this charm to work.
> You can learn more at https://anbox-cloud.io

> **WARNING:** The *Ubuntu Advantage for **Infrastructure*** token every user gets for free for personal
> use does **NOT** work and will result in a failed deployment! You need to use a valid
> *Ubuntu Advantage for **Applications*** token to be able to deploy successfully.

## Anbox Stream Agent

The Anbox Stream Agent is a charm deployed in each region of your deployment. It establishes a
connection between the main entrypoint for streaming (the Anbox Stream Gateway) and AMS while
keeping AMS secure and unexposed to public networks.

It also allows containers to be created as close to the user as possible by configuring
geographical regions.

```sh
$ juju deploy cs:~anbox-charmers/anbox-stream-agent
$ juju config anbox-stream-agent ua_token=<your UA token>
$ juju relate ams anbox-stream-agent
```

For more information about streaming, visit the official documentation
on https://anbox-cloud.io/docs/manage/streaming-android-applications
